import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import jlegocom.*;

/***************************************************************
 *The class ControlApplet is a sample applet for showing how
 *to use jlegocom to Control a local device from a webpage.
 *
 *@see <img src="../source.gif"><a href="ControlApplet/ControlApplet.java">java-source-code</a>
 *@see <img src="../source.gif"><a href="../index.html" target="_parent">jlegocom help docs</a>
 *
 *@version 0.1, 05/2002
 *@author Gerald Kogler
****************************************************************/
public class ControlApplet extends Applet implements RobotJavaListener, MouseListener
{
	private static boolean DEBUG=true;
	private RobotEventAdapter robAdapter;
	private MediaTracker mt;	
	private String host;
	private int APP_WIDTH = 170,
							APP_HEIGHT = APP_WIDTH;
	private static int 	IMG_BG_X = 0,
											IMG_BG_Y = IMG_BG_X,
											IMG_ON_X = 63,
											IMG_ON_Y = IMG_ON_X,
											IMG_UP_X = IMG_ON_X,
											IMG_UP_Y = 10,
											IMG_DOWN_X = IMG_ON_X,
											IMG_DOWN_Y = 115,
											IMG_LEFT_X = IMG_UP_Y,
											IMG_LEFT_Y = IMG_ON_Y,
											IMG_RIGHT_X = IMG_DOWN_Y,
											IMG_RIGHT_Y = IMG_ON_Y,
											IMG_WIDTH = 45,
											IMG_HEIGHT = IMG_WIDTH,
											IMG_TXT_X = IMG_BG_X,
											IMG_TXT_Y = 170,
											IMG_TXT_WIDTH = 170,
											IMG_TXT_HEIGHT = 42;
	private static String IMG_DIR = "images/",
												IMG_BG = "all.gif",
												IMG_ON = "encendido.jpg",
												IMG_OFF = "apagado.jpg",
												IMG_UP = "adelante.jpg",
												IMG_UP_ON = "b_adelante.jpg",
												IMG_DOWN = "atras.jpg",
												IMG_DOWN_ON = "b_atras.jpg",
												IMG_LEFT = "dcha.jpg",	
												IMG_LEFT_ON = "b_dcha.jpg",
												IMG_RIGHT = "izq.jpg",
												IMG_RIGHT_ON = "b_izq.jpg",
												IMG_TXT_CON = "conectado.gif",
												IMG_TXT_NOW = "conectarse.gif",
												IMG_TXT_TRY = "espera.gif",
												IMG_TXT_OUT = "descone.gif",
												IMG_TXT_MAS = "mastarde.gif";	
	private Image bgpuffer, imgBg, imgOn, imgOff, imgUp, imgUpOn, imgDown, imgDownOn, imgLeft, imgLeftOn,
	imgRight, imgRightOn, imgTxtCon, imgTxtNow, imgTxtTry, imgTxtOut, imgTxtMas;
	private Graphics bg;
	private boolean online = false,
									connecting = true,
									free = false,
									noRobot = false,
									onPressed = false,
									upPressed = false,
									downPressed = false,
									leftPressed = false,
									rightPressed = false,
									onChanged = false,
									upChanged = false,
									downChanged = false,
									leftChanged = false,
									rightChanged = false,
									txtChanged = false;
	
  /*************************************************************************
   *Constructor for the ControlApplet.
  *************************************************************************/
	public ControlApplet(){}

  /*************************************************************************
   *Inits the ControlApplet.
  *************************************************************************/
	public void init()
	{
		host = this.getCodeBase().getHost();
		System.out.println("Applet on Host: "+host);
		robAdapter = new RobotEventAdapter(host, this);
		robAdapter.start();
		
		this.getParameters();
		this.loadImages();
		
		this.addMouseListener(this);
	}
	
  /*************************************************************************
   *Reads parameters from html-file.
  *************************************************************************/
	private void getParameters()
	{
		 //read applet width
    String appWidthString = getParameter("WIDTH");
    if (appWidthString != null) {
      try { APP_WIDTH = Integer.parseInt(appWidthString);}
      catch (NumberFormatException e) {}
    }        

    //read applet height    
    String appHeightString = getParameter("HEIGHT");
    if (appHeightString != null) {
      try { APP_HEIGHT = Integer.parseInt(appHeightString);}
      catch (NumberFormatException e) {}
    }
	}
	
  /*************************************************************************
   *Loads images used by the applet.
  *************************************************************************/
	private void loadImages()
	{
		//load images
		mt=new MediaTracker(this);
		imgBg = this.getImage(this.getCodeBase(),IMG_DIR+IMG_BG);
		mt.addImage(imgBg,0);
		imgOn = this.getImage(this.getCodeBase(),IMG_DIR+IMG_ON);
		mt.addImage(imgOn,1);
		imgOff = this.getImage(this.getCodeBase(),IMG_DIR+IMG_OFF);
		mt.addImage(imgOff,2);
		imgUp = this.getImage(this.getCodeBase(),IMG_DIR+IMG_UP);
		mt.addImage(imgUp,3);
		imgUpOn = this.getImage(this.getCodeBase(),IMG_DIR+IMG_UP_ON);
		mt.addImage(imgUpOn,4);
		imgDown = this.getImage(this.getCodeBase(),IMG_DIR+IMG_DOWN);
		mt.addImage(imgDown,5);
		imgDownOn = this.getImage(this.getCodeBase(),IMG_DIR+IMG_DOWN_ON);
		mt.addImage(imgDownOn,6);
		imgLeft = this.getImage(this.getCodeBase(),IMG_DIR+IMG_LEFT);
		mt.addImage(imgLeft,7);
		imgLeftOn = this.getImage(this.getCodeBase(),IMG_DIR+IMG_LEFT_ON);
		mt.addImage(imgLeftOn,8);
		imgRight = this.getImage(this.getCodeBase(),IMG_DIR+IMG_RIGHT);
		mt.addImage(imgRight,9);
		imgRightOn = this.getImage(this.getCodeBase(),IMG_DIR+IMG_RIGHT_ON);
		mt.addImage(imgRightOn,10);
		imgTxtCon = this.getImage(this.getCodeBase(),IMG_DIR+IMG_TXT_CON);
		mt.addImage(imgTxtCon,11);
		imgTxtNow = this.getImage(this.getCodeBase(),IMG_DIR+IMG_TXT_NOW);
		mt.addImage(imgTxtNow,12);
		imgTxtMas = this.getImage(this.getCodeBase(),IMG_DIR+IMG_TXT_MAS);
		mt.addImage(imgTxtMas,13);
		imgTxtOut = this.getImage(this.getCodeBase(),IMG_DIR+IMG_TXT_OUT);
		mt.addImage(imgTxtOut,14);
		imgTxtTry = this.getImage(this.getCodeBase(),IMG_DIR+IMG_TXT_TRY);
		mt.addImage(imgTxtTry,15);
		
		try { mt.waitForAll(); }
  	catch (InterruptedException ex) {}
	}
	
  /*************************************************************************
   *Paint-method of the applet.
	 *
	 *@param g Graphics to paint to. 
  *************************************************************************/
	public void paint(Graphics g)
	{
		if (bgpuffer == null) {
			bgpuffer = createImage(APP_WIDTH, APP_HEIGHT);
			bg = bgpuffer.getGraphics();
			bg.drawImage(imgBg, IMG_BG_X, IMG_BG_Y, null);
			bg.drawImage(imgUp,IMG_UP_X,IMG_UP_Y,null);
			bg.drawImage(imgDown,IMG_DOWN_X,IMG_DOWN_Y,null);
			bg.drawImage(imgLeft,IMG_LEFT_X,IMG_LEFT_Y,null);
			bg.drawImage(imgRight,IMG_RIGHT_X,IMG_RIGHT_Y,null);
			bg.drawImage(imgOff,IMG_ON_X,IMG_ON_Y,null);
			bg.drawImage(imgTxtTry,IMG_TXT_X,IMG_TXT_Y,null);
			super.paint(bg);
			this.sendInit();
		}	
		g.drawImage(bgpuffer, IMG_BG_X, IMG_BG_Y, this);
  }
	
  /*************************************************************************
   *Update-method of the applet.
	 *
	 *@param g Graphics to update. 
  *************************************************************************/
	public void update(Graphics g)
	{
		if (upChanged){
			if (upPressed) bg.drawImage(imgUpOn,IMG_UP_X,IMG_UP_Y,null);
			else bg.drawImage(imgUp,IMG_UP_X,IMG_UP_Y,null);
			upChanged = false;
		}
		else if (downChanged){
			if (downPressed) bg.drawImage(imgDownOn,IMG_DOWN_X,IMG_DOWN_Y,null);
			else bg.drawImage(imgDown,IMG_DOWN_X,IMG_DOWN_Y,null);
			downChanged = false;
		}
		else if (leftChanged){
			if (leftPressed) bg.drawImage(imgLeftOn,IMG_LEFT_X,IMG_LEFT_Y,null);
			else bg.drawImage(imgLeft,IMG_LEFT_X,IMG_LEFT_Y,null);
			leftChanged = false;
		}
		else if (rightChanged){
			if (rightPressed) bg.drawImage(imgRightOn,IMG_RIGHT_X,IMG_RIGHT_Y,null);
			else bg.drawImage(imgRight,IMG_RIGHT_X,IMG_RIGHT_Y,null);
			rightChanged = false;
		}
		else if (onChanged){
			if (onPressed && (connecting || online)) bg.drawImage(imgOn,IMG_ON_X,IMG_ON_Y,null);	
			else bg.drawImage(imgOff,IMG_ON_X,IMG_ON_Y,null);	
			onChanged = false;
		}
		if (txtChanged){
			if (online) bg.drawImage(imgTxtCon, IMG_TXT_X, IMG_TXT_Y,null);
			else if (noRobot) bg.drawImage(imgTxtOut, IMG_TXT_X, IMG_TXT_Y,null);
			else if (connecting) bg.drawImage(imgTxtTry, IMG_TXT_X, IMG_TXT_Y,null);
			else if (free) bg.drawImage(imgTxtNow, IMG_TXT_X, IMG_TXT_Y,null);
			else if (!free) bg.drawImage(imgTxtMas, IMG_TXT_X, IMG_TXT_Y,null);
			txtChanged = false;
		}
		super.paint(bg);
  	g.drawImage(bgpuffer, IMG_BG_X, IMG_BG_Y, this);	
	}	
	
  /*************************************************************************
   *Method for Mousehandling.
	 *
	 *@param ev MouseEvent to handle. 
  *************************************************************************/
	public void mouseClicked(MouseEvent ev){}
	
  /*************************************************************************
   *Method for Mousehandling.
	 *
	 *@param ev MouseEvent to handle. 
  *************************************************************************/
	public void mousePressed(MouseEvent ev)
	{
		int x = ev.getX();
		int y = ev.getY();
		
		if (online){
			if ((x>=IMG_UP_X)&&(x<=IMG_UP_X+IMG_WIDTH)&&(y>=IMG_UP_Y)&&(y<=IMG_UP_Y+IMG_HEIGHT)){
				this.sendEventToRobot("JLEGO UP "+host);
				upPressed = true;
				upChanged = true;
				repaint(IMG_UP_X, IMG_UP_Y, IMG_WIDTH, IMG_HEIGHT);
			}	
			else if ((x>=IMG_DOWN_X)&&(x<=IMG_DOWN_X+IMG_WIDTH)&&(y>=IMG_DOWN_Y)&&(y<=IMG_DOWN_Y+IMG_HEIGHT)){
				this.sendEventToRobot("JLEGO DOWN "+host);
				downPressed = true;
				downChanged = true;
				repaint(IMG_DOWN_X, IMG_DOWN_Y, IMG_WIDTH, IMG_HEIGHT);
			}	
			else if ((x>=IMG_LEFT_X)&&(x<=IMG_LEFT_X+IMG_WIDTH)&&(y>=IMG_LEFT_Y)&&(y<=IMG_LEFT_Y+IMG_HEIGHT)){
				this.sendEventToRobot("JLEGO IZQU "+host);
				leftPressed = true;
				leftChanged = true;
				repaint(IMG_LEFT_X, IMG_LEFT_Y, IMG_WIDTH, IMG_HEIGHT);
			}	
			else if ((x>=IMG_RIGHT_X)&&(x<=IMG_RIGHT_X+IMG_WIDTH)&&(y>=IMG_RIGHT_Y)&&(y<=IMG_RIGHT_Y+IMG_HEIGHT)){
				this.sendEventToRobot("JLEGO DERE "+host);
				rightPressed = true;
				rightChanged = true;
				repaint(IMG_RIGHT_X, IMG_RIGHT_Y, IMG_WIDTH, IMG_HEIGHT);
			}	
		}
		if (free){
			if ((x>=IMG_ON_X)&&(x<=IMG_ON_X+IMG_WIDTH)&&(y>=IMG_ON_Y)&&(y<=IMG_ON_Y+IMG_HEIGHT)){
				if (online || connecting) {
					this.sendEventToRobot("JLEGO DISCON "+host);
					connecting = false;
					online = false;
				}
				else {
					this.sendEventToRobot("JLEGO CON "+host);
					connecting = true;
				}
				onPressed = true;
				onChanged = true;
				repaint(IMG_ON_X, IMG_ON_Y, IMG_WIDTH, IMG_HEIGHT);
				txtChanged = true;
				repaint(IMG_TXT_X, IMG_TXT_Y, IMG_TXT_WIDTH, IMG_TXT_HEIGHT);
			}
		}
	}
	
  /*************************************************************************
   *Method for Mousehandling.
	 *
	 *@param ev MouseEvent to handle. 
  *************************************************************************/
	public void mouseReleased(MouseEvent ev)
	{
		if (upPressed){
			this.sendEventToRobot("JLEGO STOP "+host);
			upPressed = false;
			upChanged = true;
			repaint(IMG_UP_X, IMG_UP_Y, IMG_WIDTH, IMG_HEIGHT);
		}
		else if (downPressed){
			this.sendEventToRobot("JLEGO STOP "+host);
			downPressed = false;
			downChanged = true;
			repaint(IMG_DOWN_X, IMG_DOWN_Y, IMG_WIDTH, IMG_HEIGHT);
		}
		else if (leftPressed){
			this.sendEventToRobot("JLEGO STOP "+host);
			leftPressed = false;
			leftChanged = true;
			repaint(IMG_LEFT_X, IMG_LEFT_Y, IMG_WIDTH, IMG_HEIGHT);
		}
		else if (rightPressed){
			this.sendEventToRobot("JLEGO STOP "+host);
			rightPressed = false;
			rightChanged = true;
			repaint(IMG_RIGHT_X, IMG_RIGHT_Y, IMG_WIDTH, IMG_HEIGHT);
		}
	}
	
  /*************************************************************************
   *Method for Mousehandling.
	 *
	 *@param ev MouseEvent to handle. 
  *************************************************************************/
	public void mouseEntered(MouseEvent ev){}
	
  /*************************************************************************
   *Method for Mousehandling.
	 *
	 *@param ev MouseEvent to handle. 
  *************************************************************************/
	public void mouseExited(MouseEvent ev){}


	/****************************************
	*Sends the command to init a remote-control.
	****************************************/
	private void sendInit()
	{
		this.sendEventToRobot("JLEGO INIT "+host);
	}

  /*************************************************************************
   *Method for sending commands to robot.
	 *
	 *@param cmd Command to send to robot.
  *************************************************************************/
	private void sendEventToRobot(String cmd)
	{
		System.out.println("send to robot: "+cmd);
		robAdapter.send(cmd);
	}

	/****************************************
  *Method for receiving commands from robot.
	*
	*@param cmd Command received from robot.
 	****************************************/		
	public void cmdReceived(String cmd)
	{
		if (cmd != null){
			if (DEBUG) System.out.println(">>> ACTION: "+cmd);
			if (cmd.equals("JLEGO ONLINE")){
				online = true;
				onChanged = true;
				repaint(IMG_ON_X, IMG_ON_Y, IMG_WIDTH, IMG_HEIGHT);
				txtChanged = true;
				repaint(IMG_TXT_X, IMG_TXT_Y, IMG_TXT_WIDTH, IMG_TXT_HEIGHT);
			}
			else if (cmd.equals("JLEGO OFFLINE")){
				online = false;
				onChanged = true;
				repaint(IMG_ON_X, IMG_ON_Y, IMG_WIDTH, IMG_HEIGHT);
				txtChanged = true;
				connecting = false;
				repaint(IMG_TXT_X, IMG_TXT_Y, IMG_TXT_WIDTH, IMG_TXT_HEIGHT);
			}
			else if (cmd.equals("JLEGO FREE")){
				connecting = false;
				free = true;
				txtChanged = true;
				repaint(IMG_TXT_X, IMG_TXT_Y, IMG_TXT_WIDTH, IMG_TXT_HEIGHT);
			}			
			else if (cmd.equals("JLEGO NOTFREE")){
				connecting = false;
				free = false;
				txtChanged = true;
				repaint(IMG_TXT_X, IMG_TXT_Y, IMG_TXT_WIDTH, IMG_TXT_HEIGHT);
			}		
			else if (cmd.equals("JLEGO OUT")){
				connecting = false;
				free = false;
				noRobot = true;
				txtChanged = true;
				repaint(IMG_TXT_X, IMG_TXT_Y, IMG_TXT_WIDTH, IMG_TXT_HEIGHT);
			}	
		}
	}
}
