package jlegocom;

import java.io.*;
import java.net.*;
import java.util.*;


/***************************************************************
****************************************************************/
public class RobotCommThread extends Thread
{
	Socket socket;
	PrintStream outStream;
	BufferedReader inStream;
	LegoAdapter console;
	boolean appOK;


	/*************************************************************************
  *************************************************************************/
	public RobotCommThread(String name, Socket socket, LegoAdapter console)
	{
		super(name);
		this.socket = socket;
		this.console = console;
		this.appOK = true;

		System.out.println("***********");
		
		try{
			outStream = new PrintStream(socket.getOutputStream());
			inStream = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			System.out.println(this.getName()+": O Robot connected");
		}
		catch(IOException e){
			System.out.println(this.getName()+": X Problem while Robot connected: "+e);
		}
	}

	/*************************************************************************
  *************************************************************************/
	public void run()
	{
		String cmd;
		boolean running = true;
				
		try{
			while(running){
			
				if ((cmd = inStream.readLine()) != null) {
					System.out.println("*************");
					System.out.println(this.getName()+": READ FROM ROBOT: <"+cmd+">");
					
					if (cmd.startsWith("PING")){
						System.out.println(this.getName()+"got PING");
						this.appOK = true;
					}
				}
			}	
		}
		catch(IOException e){
			System.out.println(this.getName()+": X broken communication with robot-> reaccepting matrix");
			running = false;
		}
		finally{
			try{ socket.close(); }
			catch(IOException e){}
		}
	}
	
  /*****************************************************************
	******************************************************************/
  public void destroy()
	{
		System.out.println(this.getName()+": destroyed!");
	
		try{
			socket.close();
			socket = null;
			inStream.close();
			inStream = null;
  		outStream.close();
			outStream = null;
		}
		catch(IOException e){
			System.out.println(this.getName()+": "+e);
		}
  }
	
	/*************************************************************************
  *************************************************************************/	
	public boolean isOK()
	{
		return(this.appOK);
	}

	/*************************************************************************
  *************************************************************************/	
	public void setNotOK()
	{
		this.appOK = false;
	}
}
