package jlegocom;

import java.util.*;

/***************************************************************************
*The TIMER-Thread controls if a user is connected more than 5 minutes and
*throws him out if that is so -> another user can get the control.
****************************************************************************/
public class Timer extends Thread
{
	LegoAdapter adapter;
	private volatile Thread t;
	private static final int SLEEP = 300000; // = 5 min
	private int mil = 1000,
							sec_sleep = SLEEP/mil;
	private static final boolean DEBUG = false;
	      
	public Timer(LegoAdapter adapter)
	{
		this.adapter = adapter;
	}
	
	/*************************************************************************
   *Start-method of Ping-Thread.
  *************************************************************************/
	public void start()
	{
		t = new Thread(this);
		t.start();
		if (DEBUG) System.out.println("***TIMER started!...");
	}
	
	/*************************************************************************
   *Stop-method of Ping-Thread.
  *************************************************************************/
	public void stopme()
	{
		t=null;
		if (DEBUG) System.out.println("***TIMER stopped!...");
	}
	
	/*************************************************************************
   *Run-method of Ping-Thread.
  *************************************************************************/
	public void run()
	{
		Thread thisThread = Thread.currentThread();
		
		while(t==thisThread){
			try{
				for (int i = 0; i < sec_sleep; i++){
					thisThread.sleep(mil);
					if (DEBUG) System.out.println("***TIMER sleeping..."+i);
					if (t == null) break;
				}
				adapter.forgetControl();
			}
			catch(InterruptedException e){}
		}
	}
}

