package jlegocom;

import java.util.*;

/***************************************************************************
 move robot if 5 minutes without connection
****************************************************************************/
public class WorkTimer extends Object implements Runnable
{
	LegoAdapter adapter;
	private volatile Thread t;
	private static final int SLEEP = 300000; // = 5 min
	private static final boolean DEBUG = false;
	      
	public WorkTimer(LegoAdapter adapter)
	{
		this.adapter = adapter;
	}
	
	/*************************************************************************
   *Start-method of Ping-Thread.
  *************************************************************************/
	public void start()
	{
		t = new Thread(this);
		t.start();
		if (DEBUG) System.out.println("***TIMER started!...");
	}
	
	/*************************************************************************
   *Stop-method of Ping-Thread.
  *************************************************************************/
	public void stop()
	{
		t=null;
		if (DEBUG) System.out.println("***TIMER stopped!...");
	}
	
	/*************************************************************************
   *Run-method of Ping-Thread.
  *************************************************************************/
	public void run()
	{
		Thread thisThread = Thread.currentThread();
		
		while(t==thisThread){
			try{
				thisThread.sleep(SLEEP);
				boolean sent = adapter.sendToRobot("JLEGO MOVE");
			}
			catch(InterruptedException e){}
		}
	}
}

